Subject: Problems using shmht Session Cache in Apache 2.0.39

From: [email-masked]
Date: Fri, 12 Jul 2002 15:23:03 +0200

Hi,

I'm trying to use shmht Session Cache in Apache 2.0.39 on Solaris8. I 
get the followin g message in the error_log:
[Fri Jul 12 14:20:39 2002] [error] initialize MM bogus %pRMM 

My settings regarding session cache are as follows:
SSLSessionCache         shmht:/users/webs/apache/log/ssl_gcache_data(640
00)
SSLSessionCacheTimeout  300

I traced this down to the following snippet from /modules/ssl/ssl_scache
_shmht.c :

void ssl_scache_shmht_init(server_rec *s, apr_pool_t *p)
{
    SSLModConfigRec *mc = myModConfig(s);
    table_t *ta;
    int ta_errno;
    apr_size_t avail;
    int n;
    apr_status_t rv;

    /*
     * Create shared memory segment
     */
    if (mc->szSessionCacheDataFile == NULL) {
        ap_log_error(APLOG_MARK, APLOG_ERR, 0, s,
                     "SSLSessionCache required");
        ssl_die();
    }

    if ((rv = apr_shm_create(&(mc->pSessionCacheDataMM), 
                   mc->nSessionCacheDataSize, 
                   mc->szSessionCacheDataFile, mc->pPool)) != 
APR_SUCCESS) {
        ap_log_error(APLOG_MARK, APLOG_ERR, rv, s,
                     "Cannot allocate shared memory");
        ssl_die();
    }

    if ((rv = apr_rmm_init(&(mc->pSessionCacheDataRMM), NULL,
                   apr_shm_baseaddr_get(mc->pSessionCacheDataMM),
                   mc->nSessionCacheDataSize, mc->pPool)) != 
APR_SUCCESS) {
        ap_log_error(APLOG_MARK, APLOG_ERR, rv, s,
                     "Cannot initialize rmm");
        ssl_die();
    }
    ap_log_error(APLOG_MARK, APLOG_ERR, 0, s,
                 "initialize MM %p RMM %p",
                 mc->pSessionCacheDataMM, mc->pSessionCacheDataRMM);

The last line seems strange. Why is a error message printed if there is 
nothing wrong? Shouldn't APLOG_ERR be changed to APLOG_INFO ? And are 
the values to be printed correctly set?

BTW: shmcb works without problems.

Has anybody noticed the same problem?

Cheers
	Georg

UUNET - a WorldCom Company
UUNET Deutschland GmbH
Sebrathweg 20
44149 Dortmund
Germany

Tel. +49 231 972 1128
Fax. +49 231 972 1180
[email-masked]
http://www.worldcom.com/de/

______________________________________________________________________
Apache Interface to OpenSSL (mod_ssl)                   www.modssl.org
User Support Mailing List                      [email-masked]
Automated List Manager                            [email-masked]